Package org.optaplanner.core.impl.score.director.incremental

## Class IncrementalScoreDirector<Solution_,​Score_ extends Score<Score_>>

- java.lang.Object
- - org.optaplanner.core.impl.score.director.AbstractScoreDirector<Solution_,​Score_,​IncrementalScoreDirectorFactory<Solution_,​Score_>>
  - - org.optaplanner.core.impl.score.director.incremental.IncrementalScoreDirector<Solution_,​Score_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
    `Score_` - the score type to go with the solution
  All Implemented Interfaces:
    `AutoCloseable`, `Cloneable`, `ScoreDirector<Solution_>`, `InnerScoreDirector<Solution_,​Score_>`

      public class IncrementalScoreDirector<Solution_,​Score_ extends Score<Score_>>
      extends AbstractScoreDirector<Solution_,​Score_,​IncrementalScoreDirectorFactory<Solution_,​Score_>>

  Incremental java implementation of `ScoreDirector`, which only recalculates the `Score` of the part of the `working solution` that changed, instead of the going through the entire `PlanningSolution`. This is incremental calculation, which is fast.
  See Also:
    `ScoreDirector`

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirector

      `allChangesWillBeUndoneBeforeStepEnds, calculationCount, constraintMatchEnabledPreference, logger, lookUpEnabled, lookUpManager, scoreDirectorFactory, variableListenerSupport, workingEntityListRevision, workingInitScore, workingSolution`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `IncrementalScoreDirector​(IncrementalScoreDirectorFactory<Solution_,​Score_> scoreDirectorFactory, boolean lookUpEnabled, boolean constraintMatchEnabledPreference, IncrementalScoreCalculator<Solution_,​Score_> incrementalScoreCalculator)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `afterEntityAdded​(EntityDescriptor<Solution_> entityDescriptor, Object entity)` |
    `void` | `afterEntityRemoved​(EntityDescriptor<Solution_> entityDescriptor, Object entity)` |
    `void` | `afterProblemFactAdded​(Object problemFact)` |
    `void` | `afterProblemFactRemoved​(Object problemFact)` |
    `void` | `afterProblemPropertyChanged​(Object problemFactOrEntity)` |
    `void` | `afterVariableChanged​(VariableDescriptor variableDescriptor, Object entity)` |
    `void` | `beforeEntityAdded​(EntityDescriptor<Solution_> entityDescriptor, Object entity)` |
    `void` | `beforeEntityRemoved​(EntityDescriptor<Solution_> entityDescriptor, Object entity)` |
    `void` | `beforeProblemFactAdded​(Object problemFact)` |
    `void` | `beforeProblemFactRemoved​(Object problemFact)` |
    `void` | `beforeProblemPropertyChanged​(Object problemFactOrEntity)` |
    `void` | `beforeVariableChanged​(VariableDescriptor variableDescriptor, Object entity)` |
    `Score_` | `calculateScore()` | Calculates the `Score` and updates the `working solution` accordingly.
    `Map<String,​ConstraintMatchTotal<Score_>>` | `getConstraintMatchTotalMap()` | Explains the `Score` of `InnerScoreDirector.calculateScore()` by splitting it up per `Constraint`.
    `IncrementalScoreCalculator<Solution_,​Score_>` | `getIncrementalScoreCalculator()` |
    `Map<Object,​Indictment<Score_>>` | `getIndictmentMap()` | Explains the impact of each planning entity or problem fact on the `Score`.
    `boolean` | `isConstraintMatchEnabled()` |
    `void` | `setWorkingSolution​(Solution_ workingSolution)` | The `working solution` must never be the same instance as the `best solution`, it should be a (un)changed clone.

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirector

      `afterEntityAdded, afterEntityRemoved, afterVariableChanged, assertExpectedUndoMoveScore, assertExpectedWorkingScore, assertNonNullPlanningIds, assertPredictedScoreFromScratch, assertShadowVariablesAreNotStale, assertWorkingScoreFromScratch, beforeEntityAdded, beforeEntityRemoved, beforeVariableChanged, buildScoreCorruptionAnalysis, buildShadowVariableAnalysis, changeVariableFacade, clone, cloneSolution, cloneWorkingSolution, close, createChildThreadScoreDirector, createShadowVariablesViolationMessage, doAndProcessMove, doAndProcessMove, getCalculationCount, getScoreDefinition, getScoreDirectorFactory, getSolutionDescriptor, getSupplyManager, getWorkingEntityCount, getWorkingEntityList, getWorkingEntityListRevision, getWorkingSolution, getWorkingValueCount, isAllChangesWillBeUndoneBeforeStepEnds, isConstraintMatchEnabledPreference, isLookUpEnabled, isWorkingEntityListDirty, lookUpWorkingObject, lookUpWorkingObjectOrReturnNull, overwriteConstraintMatchEnabledPreference, resetCalculationCount, setAllChangesWillBeUndoneBeforeStepEnds, setCalculatedScore, setWorkingEntityListDirty, toString, triggerVariableListeners`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### IncrementalScoreDirector

          public IncrementalScoreDirector​(IncrementalScoreDirectorFactory<Solution_,​Score_> scoreDirectorFactory,
                                          boolean lookUpEnabled,
                                          boolean constraintMatchEnabledPreference,
                                          IncrementalScoreCalculator<Solution_,​Score_> incrementalScoreCalculator)

  - ### Method Detail

    - #### getIncrementalScoreCalculator

          public IncrementalScoreCalculator<Solution_,​Score_> getIncrementalScoreCalculator()

    - #### setWorkingSolution

          public void setWorkingSolution​(Solution_ workingSolution)

      Description copied from interface: `InnerScoreDirector`
      The `working solution` must never be the same instance as the `best solution`, it should be a (un)changed clone.
      Specified by:
        `setWorkingSolution` in interface `InnerScoreDirector<Solution_,​Score_ extends Score<Score_>>`
      Overrides:
        `setWorkingSolution` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`
      Parameters:
        `workingSolution` - never null

    - #### calculateScore

          public Score_ calculateScore()

      Description copied from interface: `InnerScoreDirector`
      Calculates the `Score` and updates the `working solution` accordingly.
      Returns:
        never null, the `Score` of the `working solution`

    - #### isConstraintMatchEnabled

          public boolean isConstraintMatchEnabled()

      Returns:
        true if `InnerScoreDirector.getConstraintMatchTotalMap()` and `InnerScoreDirector.getIndictmentMap()` can be called

    - #### getConstraintMatchTotalMap

          public Map<String,​ConstraintMatchTotal<Score_>> getConstraintMatchTotalMap()

      Description copied from interface: `InnerScoreDirector`
      Explains the `Score` of `InnerScoreDirector.calculateScore()` by splitting it up per `Constraint`.

      The sum of `ConstraintMatchTotal.getScore()` equals `InnerScoreDirector.calculateScore()`.

      Call `InnerScoreDirector.calculateScore()` before calling this method, unless that method has already been called since the last `PlanningVariable` changes.

      Returns:
        never null, the key is the `constraintId` (to create one, use `ConstraintMatchTotal.composeConstraintId(String, String)`).
      See Also:
        `InnerScoreDirector.getIndictmentMap()`

    - #### getIndictmentMap

          public Map<Object,​Indictment<Score_>> getIndictmentMap()

      Description copied from interface: `InnerScoreDirector`
      Explains the impact of each planning entity or problem fact on the `Score`. An `Indictment` is basically the inverse of a `ConstraintMatchTotal`: it is a `Score` total for each justification `Object` in `ConstraintMatch.getJustificationList()`.

      The sum of `ConstraintMatchTotal.getScore()` differs from `InnerScoreDirector.calculateScore()` because each `ConstraintMatch.getScore()` is counted for each justification in `ConstraintMatch.getJustificationList()`.

      Call `InnerScoreDirector.calculateScore()` before calling this method, unless that method has already been called since the last `PlanningVariable` changes.

      Returns:
        never null, the key is a `problem fact` or a `planning entity`
      See Also:
        `InnerScoreDirector.getConstraintMatchTotalMap()`

    - #### beforeEntityAdded

          public void beforeEntityAdded​(EntityDescriptor<Solution_> entityDescriptor,
                                        Object entity)

      Overrides:
        `beforeEntityAdded` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### afterEntityAdded

          public void afterEntityAdded​(EntityDescriptor<Solution_> entityDescriptor,
                                       Object entity)

      Overrides:
        `afterEntityAdded` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### beforeVariableChanged

          public void beforeVariableChanged​(VariableDescriptor variableDescriptor,
                                            Object entity)

      Specified by:
        `beforeVariableChanged` in interface `InnerScoreDirector<Solution_,​Score_ extends Score<Score_>>`
      Overrides:
        `beforeVariableChanged` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### afterVariableChanged

          public void afterVariableChanged​(VariableDescriptor variableDescriptor,
                                           Object entity)

      Specified by:
        `afterVariableChanged` in interface `InnerScoreDirector<Solution_,​Score_ extends Score<Score_>>`
      Overrides:
        `afterVariableChanged` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### beforeEntityRemoved

          public void beforeEntityRemoved​(EntityDescriptor<Solution_> entityDescriptor,
                                          Object entity)

      Overrides:
        `beforeEntityRemoved` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### afterEntityRemoved

          public void afterEntityRemoved​(EntityDescriptor<Solution_> entityDescriptor,
                                         Object entity)

      Overrides:
        `afterEntityRemoved` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### beforeProblemFactAdded

          public void beforeProblemFactAdded​(Object problemFact)

      Specified by:
        `beforeProblemFactAdded` in interface `ScoreDirector<Solution_>`
      Overrides:
        `beforeProblemFactAdded` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### afterProblemFactAdded

          public void afterProblemFactAdded​(Object problemFact)

      Specified by:
        `afterProblemFactAdded` in interface `ScoreDirector<Solution_>`
      Overrides:
        `afterProblemFactAdded` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### beforeProblemPropertyChanged

          public void beforeProblemPropertyChanged​(Object problemFactOrEntity)

      Specified by:
        `beforeProblemPropertyChanged` in interface `ScoreDirector<Solution_>`
      Overrides:
        `beforeProblemPropertyChanged` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### afterProblemPropertyChanged

          public void afterProblemPropertyChanged​(Object problemFactOrEntity)

      Specified by:
        `afterProblemPropertyChanged` in interface `ScoreDirector<Solution_>`
      Overrides:
        `afterProblemPropertyChanged` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### beforeProblemFactRemoved

          public void beforeProblemFactRemoved​(Object problemFact)

      Specified by:
        `beforeProblemFactRemoved` in interface `ScoreDirector<Solution_>`
      Overrides:
        `beforeProblemFactRemoved` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`

    - #### afterProblemFactRemoved

          public void afterProblemFactRemoved​(Object problemFact)

      Specified by:
        `afterProblemFactRemoved` in interface `ScoreDirector<Solution_>`
      Overrides:
        `afterProblemFactRemoved` in class `AbstractScoreDirector<Solution_,​Score_ extends Score<Score_>,​IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>>`